<?php
    /**
    *   D Y N P G  -  D Y N A M I C  P A G E S
    *
    *   BACKEND FILE
    *
	*   This is a DynPG - Dynamic Pages backup file, that contains
    *   handling routines for specific parts of the plugin project
    *   in order to manage default data procedures (like insert, change, delete)
    *   and to output the existing data.
    *
    *   @package: DynPG Core
    */

    if ( !dynpg_getRightsToUser(C_RIGHTS_GIVERIGHT) ) {
        exit;
    }

	// ---------------------------------------------------------------------
	// imports

	require dirname(__FILE__) . "/api/db_api.php";

    require_once "connectdb.php";


    // ---------------------------------------------------------------------
	// process GET param/submit

    foreach ( $_GET as $key => $value ) {
        $_GET[$key] = addslashes(urldecode($value));
    }

    // constant params:  set the default values for GET parameters
		list($show, $selectIDX, $action, $orderby, $sort, $page, $limit, $refID, $search_query) = Array(md5('rights_3'), '', '', 'id', 'ASC', 0, 50, '', '');

    // superficial params (parameters, that perform an action directly, without needing more user data,
    // after performing an action, there have to be a redirect, using the header()-function
		list($xUser, $saveRights) = Array('', '');

    // deduce get data
	    if ( get_magic_quotes_gpc() ) {
	        $_GET = array_map(create_function('$a', 'return stripslashes($a);'), $_GET);
	    }

	    extract($_GET, EXTR_OVERWRITE);

	    $search_query = stripslashes($search_query);


    // ---------------------------------------------------------------------
	// declarations

	// functions

		// generates a query that looks like "show=$conformUri['show']&amp;selectIDX=$conformUri['selectIDX']&amp;..."
		function thisQuery() {
	        $conformUri = Array('show', 'selectIDX', 'action' , 'orderby' , 'sort' , 'page' , 'limit', 'refID', 'search_query');

	        $this_function_args = func_get_args();

	        return implode('&amp;', array_map(
						create_function('$a, $b', 'return $a . "=" . urlencode($b);'),
						$conformUri,
						$this_function_args
					)
				   );
	    }

    // variables

    	$THIS_LANGUAGE_PROC = &$GLOBALS['lang_dpg'];

		$C_WEBSITE_MAINBACKGROUND = C_WEBSITE_MAINBACKGROUND;
		$C_WEBSITE_AKTBACKGROUND  = C_WEBSITE_AKTBACKGROUND;

		$ERROR_STRING = $THIS_LANGUAGE_PROC->str['lang_articles_message_4b'];

	    // database handlers
		$dbh = Array(
            'tbl_hdl' => new DB_DynPGDB_Plugin_Rights()
        );


    // ---------------------------------------------------------------------
	// process post submit

    $Sucessfull   = true;
    $query_posted = false;

    if ( !empty($_POST['search_query']) && empty($_POST['nosearch']) ) {
        $query_posted = true;
		$search_query = stripslashes($_POST['search_query']);
    }

    if ( !empty($_POST['PG_LIMIT']) ) {
        $limit = $_POST['PG_LIMIT'];
    }

    if ( !empty($_POST['PG_SHOW']) ) {
        $page = (integer)$_POST['PG_SHOW'] - 1;
        $page = $page < 0? 0: $page;
    }

	if ( !empty($_POST['delete_queue_x']) ) {
        $action = 'delete';
        $Sucessfull = false;
    }

    if ( !empty($_POST['delete_strict_queue_x']) ) {
        $action = 'strict_delete';
        $Sucessfull = false;
    }


	//
    // create, edit, delete
    //

    if ( !empty($_POST['STATUS']) && !empty($_POST['TYPE']) ) {
        if (! get_magic_quotes_gpc() ) {
            $_POST = array_map(create_function('$a', 'return addslashes($a);'), $_POST);
        }
        switch ( $_POST['TYPE'] ) {
            case 'strict_delete':
			case 'delete':
                    if ( $_POST['Queue'] == 'yes' ) {
                        // delete queue

						foreach ( $_POST as $key => $value ) {
							if ( preg_match('/^chk/', $key) ) {
							 $dbh['tbl_hdl']->delete($value);
							}
						}
                    } else {
                        // delete single row

						$dbh['tbl_hdl']->delete($_POST['DELID'], true);
                    }
                break;

            case 'create':
                    $insert = Array(
                    	/**
						* @TODO : insert post values here
						*/
					);

					$dbh['tbl_hdl']->insert($insert);
                break;

            case 'edit':
					$update = Array(
						/**
						* @TODO : insert post values here
						*/
					);

					$dbh['tbl_hdl']->update($_POST['CHGID'], $update);
                break;

            default:
                break;
        }
    }

    // end processing post submit


	// ---------------------------------------------------------------------
	// handle superficial GET params

    if ($saveRights != '') {
        $dbhr = new DB_DynPGDB_Plugin_Rights();
        $rightHdl = new dynpgPluginRights();

        // delete existing rights for user
        $userid = $_POST['refID'];
        $dbhr->delete($userid);

        // read all new rights
        $new_rights = Array();
        foreach ($rightHdl->plugins as $plugin) {
            $new_rights[$plugin] = Array();
            for ($i = 0; $i < 25; $i++)
                $new_rights[$plugin][$i] = (isset($_POST['right_' . $plugin . '_' . $i]))? 1: 0;
        }

        // insert them into the db
        foreach ($new_rights as $plugin => $rights) {
            $dbhr->insert(
                Array(
                    $userid,
                    $plugin,
                    implode('', $rights)
                )
            );
        }

        // redirect
		header('Location: ' . dynpg_get_HTTP_URL() . '?' . str_replace('&amp;', '&', thisQuery($show, $selectIDX, '', $orderby, $sort, $page, $limit, $userid, $search_query)));
		exit;
    }


	// ---------------------------------------------------------------------
	// handle constant GET params

	// specific: read in default values for the different form fields
	// to load some data in the "value"-attribute of an form element

	/**
	* @TODO : Maybe add some specific data here (or let it blank, because the
	*		  following loop will set a default value to each form element that's
	*		  named equal to the corresponding database attribute).
	*/

//    foreach ( $dbh['tbl_hdl']->tbl_container[$dbh['tbl_hdl']->db_table]['rows'] as $row ) {
//        $_readData[$row] = '';
//    }


	// general

    $_readData['submitType']   = 'create';
    $_readData['buttonValue']  = $THIS_LANGUAGE_PROC->str['lang_articles_create_button'];

    switch ( $action ) {
        case 'strict_delete':
		case 'delete':

            $queryStr = thisQuery($show, $selectIDX, '', $orderby, $sort, $page, $limit);
            $inQueue  = empty($_POST['delete_queue_x'])? 'no': 'yes';
            $queueElm = '';

			if ( $inQueue == 'yes' ) {
                foreach ( $_POST as $key => $value ) {
                   if ( preg_match('/^chk/', $key) ) {
                        $queueElm .= '<input type="hidden" value="' . stripslashes($value) . '" name="' . stripslashes($key) . '">' . "\r\n";
                   }
               }
            }

            echo <<<STRING
                	<table border="0" Cellpadding="8" Cellspacing="0" width="400" class="InnerWebsiteTable">
                	<tr>
                		<td bgcolor="{$C_WEBSITE_MAINBACKGROUND}" valign="top">
                			<img src="pictures/innertext_info.jpg"><BR>
                			<span class="yellow">
                				<i>{$THIS_LANGUAGE_PROC->str['lang_articles_message_5']}</i>
                				<p align=right>
                				<table border="0" Cellspadding="0" Cellspacing="0">
                				 <tr>
                				  <form action="{$_SERVER['PHP_SELF']}?{$queryStr}" method="post" name="SUBMIT_DEL_GROUP">
                				  <td>
                					<input type="hidden" value="{$refID}" name="DELID">
                			 		<input type="hidden" value="SUBMITTED" name="STATUS">
                					<input type="hidden" value="{$action}" name="TYPE">
                					<input type="hidden" value="{$inQueue}" name="Queue">
                					{$queueElm}
                					<input type="submit" class="ButtonStyleWhite" value="{$THIS_LANGUAGE_PROC->str['lang_group_yes']}">
                				  </td>
                				  </form>
                				  <form action="{$_SERVER['PHP_SELF']}?{$queryStr}" method="post" name="SUBMIT_DEL_GROUP">
                				  <td>
                				  	<input type="submit" class="ButtonStyleWhite" value="{$THIS_LANGUAGE_PROC->str['lang_group_no']}">
                				  </td>
                				  </form>
                				 </tr>
                				</table>
                				</p>
                			</span>
                		</td>
                	</tr>
                	</table><BR>
STRING;
// END HTML OUTPUT
            break;

        case 'edit':
        	/**
			* @TODO : insert your own database query here, that fetches the currently
			* 		  selected item, e.g.
			*
			*		  $dbh['tbl_hdl']->readRow($refID);
			*/

			$_readData = array_map(create_function('$s', 'return dynpg_htmlentities_rigid($s,ENT_COMPAT,true);'), $dbh['tbl_hdl']->db_fetch_row());

            $_readData['submitType']   = 'edit';
            $_readData['buttonValue']  = $THIS_LANGUAGE_PROC->str['lang_articles_change_button'];
            break;

        default:
            break;
    }


    // ---------------------------------------------------------------------
	// result output

    if ( $Sucessfull ) {
    	//
		// SUCCESS
		//
        if ( !empty($_POST['STATUS']) ) {
            // HTML OUTPUT
            echo <<<STRING
            	<table border="0" Cellpadding="8" Cellspacing="0" class="InnerWebsiteTable" width="400">
            	<tr>
            		<td bgcolor="{$C_WEBSITE_MAINBACKGROUND}" valign="top">
            			<img src="pictures/innertext_info.jpg" alt="info"><br>
            			<span class="green">
            			 <em>
            				{$THIS_LANGUAGE_PROC->str['lang_message_success']}<BR>
                            <BR></span>
            			 </em>
            			</span>
            		</td>
            	</tr>
            	</table><BR>
STRING;
// END HTML OUTPUT
        }

	} else {

		//
		// FAIL
		//
        if ( !empty($_POST['STATUS']) ) {
            // HTML OUTPUT
            echo <<<STRING
            	<table border="0" Cellpadding="8" Cellspacing="0" class="InnerWebsiteTable" width="400">
            	<tr>
            		<td bgcolor="{$C_WEBSITE_MAINBACKGROUND}" valign="top">
            			<img src="pictures/innertext_info.jpg" alt="info"><BR>
            			<span class="red">
                             {$THIS_LANGUAGE_PROC->str['lang_message_failure']}
                             <br /><br />
                             {$ERROR_STRING}
            			     <br />
            			</span>
            		</td>
            	</tr>
            	</table><BR>
STRING;
// END HTML OUTPUT

            $_readData = array_merge($_readData, $_POST);
            $_readData['submitType']   = $_readData['TYPE'];
            $_readData['buttonValue']  = $_readData['TYPE'] == 'create'? $THIS_LANGUAGE_PROC->str['lang_articles_create_button']: $THIS_LANGUAGE_PROC->str['lang_articles_change_button'];
            $refID = $_readData['CHGID'];
        }
    }
?>
<h3><?php echo $THIS_LANGUAGE_PROC->str['lang_rights_title_3']; ?></h3>

<script language="javascript" type="text/javascript">
<!--
	function showHtmlThing(elementsArray)
	{
		for ( var i = 0; i< elementsArray.length; ++i )
		{
			if ( document.getElementById(elementsArray[i]).style.display == 'block' ) {
				document.getElementById(elementsArray[i]).style.display = 'none';
			} else {
				document.getElementById(elementsArray[i]).style.display = 'block';
			}
		}
	}

    var cMode = true;

    function checkOrUncheckAll() {
        $('input[type=checkbox]').each(function() {
            this.checked = cMode;
        });
        cMode = !cMode;
        return false;
    }
//--->
</script>

<table border="0" cellpadding="2" cellspacing="0" width="100%" class="InnerWebSiteTable">
	<tr>
		<td valign="top" align="left" bgcolor="<?php echo C_WEBSITE_MAINBACKGROUND ?>">
			<a href="javascript:showHtmlThing(Array('divElUser'));"><img src="pictures/bog_stock_contract.gif" alt="<?php echo $GLOBALS["lang_dpg"]->str["lang_rights_expand"]; ?>" border="0" title="<?php echo $GLOBALS["lang_dpg"]->str["lang_rights_showUser"]; ?>" /></a>
			<b><?php echo $GLOBALS["lang_dpg"]->str["lang_rights_ask_1"]; ?></b>
			<form action="" method="post" name="placeholderForm">
			<div style="margin : 10px; display:block;" id="divElUser">
				<select size="1" name="giveRights_userid" style="width:450px; font-weight: bold;" class="TextFieldStyleWhite" onChange="self.location.href='<?php echo $_SERVER['PHP_SELF']; ?>?<?php echo dynpg_htmlentities_rigid(preg_replace('/(&){0,1}refID=(\w+)/', '', $_SERVER['QUERY_STRING'] ),ENT_COMPAT,true); ?>&amp;refID='+this.form.giveRights_userid.options[this.form.giveRights_userid.options.selectedIndex].value">
					<?php
                        $mysql_result = mysql_query("SELECT * FROM `dynpg_cms_user` WHERE `INTERN` = 'FALSE' ORDER BY `NAME` ASC");

                        while ( $mysql_row = mysql_fetch_array($mysql_result, MYSQL_ASSOC) ) {
                            if (empty($refID))
                                $refID = $mysql_row['id'];

                            echo '<option value="'.$mysql_row['id'].'"';

                            if ($refID == $mysql_row['id']) {
                                echo ' selected="selected"';
                            }

                            echo '>'.dynpg_htmlentities_rigid($mysql_row['NAME'],ENT_COMPAT,true).'</option>';
                        }
                    ?>
				</select>
			</div>
			</form>
		</td>
	</tr>
</table>

<br />

<form action="<?php echo "{$_SERVER['PHP_SELF']}?" . thisQuery($show, $selectIDX, '', $orderby, $sort, $page, $limit, '', $search_query); ?>&amp;saveRights=yes" method="post" name="SUBMIT_LIST" style="margin: 0;">
<table border="0" Cellpadding="8" Cellspacing="0" width="100%" class="InnerWebsiteTable">
    <tr>
    	<td bgcolor="<?php echo C_WEBSITE_MAINBACKGROUND ?>" valign="top">

            <div style="margin-top: -10px;">
            <?php
                $dbh['tbl_hdl']->readAll($refID);
                $user_rights = Array();
                while ($row = $dbh['tbl_hdl']->db_fetch_row()) {
                    $user_rights[$row['plugin']] = $row['right_bin'];
                }

                $rightHdl = new dynpgPluginRights();
                $plugins = $rightHdl->read();

        		foreach ($plugins as $plugin => $rights) {
                    print "<div class=\"div-row-element div-row-element-title\">{$plugin}</div>";
                    foreach ($rights as $right_bin => $right_str) {
                        $selected = (!empty($user_rights[$plugin]) && substr($user_rights[$plugin], $right_bin, 1) == 1);
                        print '<div class="div-row-element"><input type="checkbox" name="right_' . $plugin . '_' . $right_bin . '" value="' . $right_bin . '" style="float: left;" ' . ($selected? 'checked="checked"': '') . '>&nbsp;' . $right_str . '</div>';
                    }
        		}
        	?>
        	</div>

        </td>
    </tr>
</table>

<br />

<table border="0" Cellpadding="8" Cellspacing="0" width="100%" class="InnerWebsiteTable">
    <tr>
        <td bgcolor="<?php echo C_WEBSITE_MAINBACKGROUND ?>" nowrap="nowrap" align="left">
            <strong><?php print $GLOBALS["lang_dpg"]->str["lang_rights_select"]; ?></strong>
            <a href="#" onclick="return checkOrUncheckAll();"><?php print $GLOBALS["lang_dpg"]->str["lang_rights_all"]; ?></a>
        </td>
    	<td bgcolor="<?php echo C_WEBSITE_MAINBACKGROUND ?>" align="right">
            <input type="hidden" name="refID" value="<?php print $refID; ?>" />
            <input type="submit" name="submit" value="<?php echo $GLOBALS["lang_dpg"]->str["lang_rights_save"]; ?>" style="width: 250px; background-image: url(pictures/button_bg-long.gif); text-align: center;" class="ButtonStyleWhite" />
        </td>
    </tr>
</table>

</form>